
static int tssh_get_remote_identification(tssh_t *T, tssh_obj_t **rembuf)
{
  uint8_t line[256+8];
  int line_len, buf_len;
  uint8_t buf[8], *remain;
  int f,i,R;

  line_len= 0;
  buf_len= 0;
read_more:
  R= tssh_recv(T, buf+buf_len, 8-buf_len);
  if (R<=0) return 1;
  buf_len+= R;

  for(i=0,f=0;!f && i<8;i++) { if (buf[i]=='\n') f=1;  }
  memcpy(line+line_len, buf, i);
  line_len+= i;
  if (line_len>255) 
  {
    tssh_log(T, "header line too long\n");
    return 1;
  }
  if (i!=8) memmove(buf, buf+i, 8-i);
  buf_len-= i;

  if (!f) goto read_more;
  
  if (line_len < 7 || memcmp(line, "SSH-2.0", 7))
  {
    line[line_len]= 0;
    tssh_report_string(T, TSSH_EVENT_CONNECT_BANNER, strdup(line));
    line_len= 0;
    goto read_more;
  }

  for(i=0;i<line_len;i++) 
    if (line[i]=='\r' || line[i]=='\n')
    {
      line[i]= 0;
      break;
    }
  T->o_remote_id= tssh_str_to_rfc(line);

  remain= malloc(8);
  memcpy(remain, buf, buf_len);
  *rembuf= tssh_obj_new(remain, buf_len);

  return 0;
}

static int tssh_send_self_identification(tssh_t *T,char *id)
{
  if (tssh_send(T, id, strlen(id))) return 1;
  if (tssh_send(T, "\r\n", 2)) return 1;
  T->o_self_id= tssh_str_to_rfc(id);
  return 0;
}

