
static tssh_algoname_t tssh_kex_algonames[]=
{
  { "diffie-hellman-group14-sha1", TSSH_KEX_DHG14_SHA1 },
  { NULL, 0 }
};

static tssh_algoname_t tssh_serverkey_algonames[]=
{
  { "ssh-rsa", TSSH_SERVERKEY_SSH_RSA },
  { NULL, 0 }
};

static tssh_algoname_t tssh_compress_algonames[]=
{
  { "none", TSSH_COMPRESS_NONE },
  { NULL, 0 }
};

static int tssh_nego_algo(tssh_obj_t *serv_o, tssh_algoname_t *client)
{
   tssh_obj_t server_list, server;
   for(;client->name;client++)
   {
     server_list= *serv_o;
     tssh_namelist_skiplen(&server_list);
     while(tssh_namelist_get(&server_list, &server))
     {
       if (server.len!=strlen(client->name)) continue;
       if (memcmp(server.data,client->name,server.len)) continue;
       return client->value;
     }                     
   }
   return -1;
}

static char *tssh_algo_names(tssh_algoname_t *list)
{
  int n;
  size_t L;
  buffer_t *B;
  char *R;

  B= buffer_new(1024);
  for(n=0;list->name;list++,n++)
  {
    if (n) buffer_write(B, ",", 1);
    buffer_write(B, list->name, strlen(list->name));
  }
  buffer_write(B, "", 1);
  buffer_free(B, (void**) &R, &L);
  return R;                        
}
