

static void tssh_hash_begin(tssh_hash_t *t) 
{
  switch(t->type)
  {
  case TSSH_SHA1: SHA1Init(&t->C.sha1); break;
  }
}

static void tssh_hash_finish(tssh_hash_t *t) {
  switch(t->type)
  {
  case TSSH_SHA1: SHA1Final(t->data, &t->C.sha1); break;
  }
}

static void tssh_hash_dealloc(tssh_hash_t *t) 
{
  switch(t->type)
  {
  case TSSH_SHA1:
    free(t->data);
    break;
  }
  memset(t, 0, sizeof(*t));
}

static void tssh_hash_update(tssh_hash_t *t,uint8_t *data,uint32_t len)
{
  switch(t->type)
  {
  case TSSH_SHA1: SHA1Update(&t->C.sha1, data, len); break;
  }
}

static void tssh_hash_obj(tssh_hash_t *t, tssh_obj_t *O)
{ 
  tssh_hash_update(t, O->data, O->len); 
}

static tssh_hash_t* tssh_hash_alloc(int type)
{
  tssh_hash_t *t;
  t= calloc(1,sizeof(*t));
  t->type= type;
  switch(type)
  {
  case TSSH_SHA1: t->data= malloc(20); t->len= 20; break;
  }
  return t;
}

static tssh_hash_t* tssh_kex_hash_alloc(int kexalgo)
{
  switch(kexalgo)
  {
  case TSSH_KEX_DHG14_SHA1: return tssh_hash_alloc(TSSH_SHA1);
  }
  return NULL;
}
