

static void tssh_msg_userauth_banner(tssh_t *T, tssh_buffer_t *pb)
{
  tssh_obj_t msg;
  uint8_t dummy;
  
  tssh_parse_byte(pb,&dummy);
  tssh_parse_string(pb, &msg);
  tssh_report_string(T, TSSH_EVENT_PASSWORD_BANNER, tssh_xstr_to_str(&msg));
}


static int tssh_msg_service_accept(tssh_t *T,tssh_buffer_t *pb)
{ 
  tssh_obj_t strobj;
  uint8_t cmd;
  tssh_opak_t *O;

  if (tssh_parse_byte(pb, &cmd) || 
      tssh_parse_string(pb, &strobj)) 
  {
    tssh_log(T, "SERVICE_ACCEPT: invalid message\n");
    return 1;
  }
  if (!tssh_xstr_compare(&strobj,"ssh-userauth")) goto userauth;
  if (!tssh_xstr_compare(&strobj,"ssh-connection")) goto connection;
  tssh_log(T, "unexpected SERVICE_ACCEPT for %S\n", &strobj);
  return 1;
userauth:
  if (T->auth_state!=1) 
  {
    tssh_log(T, "unexpected SERVICE_ACCEPT for ssh-userauth\n");
    return 1;
  }
  O= tssh_opak_begin();  
  tssh_opak_byte(O, SSH_MSG_USERAUTH_REQUEST);
  tssh_opak_string(O, T->user);
  tssh_opak_string(O, "ssh-connection");
  tssh_opak_string(O, "password");
  tssh_opak_bool(O, 0);
  tssh_opak_string(O, T->password);
  tssh_send_opak(T,O);
  T->auth_state= 2;
  return 0;
connection:
  return 0;
}

