



static void tssh_ftp_mqinit(tssh_ftp_msg_queue_t *mq)
{
   memset(mq, 0, sizeof(*mq));
}

static void tssh_ftp_mqdestroy(tssh_ftp_msg_queue_t *mq)
{
   if (mq->partial) free(mq->partial);
   if (mq->next) free(mq->next);
   memset(mq, 0, sizeof(*mq));
}







//
// ok. I'll do this one more time..
// 
//

static void tssh_ftp_mqput(tssh_ftp_msg_queue_t *mq, tssh_buffer_t *input)
{
  // this should be impossible.. all data should have been consumed 
  // by get() before calling put().
  if (mq->next) 
  {
    fprintf(stderr,"impossible happened! mqput() called while we still have "
                " ->next\n");
    return ;
  }

  mq->next= input;
}

//
// this function should be called repeatedly until it returns
// NULL. Only after that, we should add more input.
//
static tssh_buffer_t *tssh_ftp_mqget(tssh_ftp_msg_queue_t *mq)
{
  uint32_t psize, cp;
  tssh_buffer_t *R, *P;
again:
  if (mq->partial)
  {
    if (mq->partial->len==mq->psize) 
    {
      R= mq->partial;
      mq->partial= NULL;
      mq->psize= 0;
      return R;
    }
    if (!mq->next) return NULL;
    cp= mq->psize - mq->partial->len;
    if (cp>mq->next->len) cp= mq->next->len;
    memcpy(mq->partial->data + mq->partial->len, mq->next->data, cp);
    mq->partial->len += cp;

    mq->next->data += cp;
    mq->next->len -= cp;
    if (!mq->next->len) { free(mq->next); mq->next= NULL; }

    goto again;
  }

  if (!mq->next) return NULL ;

  if (mq->next->len<4) return NULL;

  tssh_parse_uint32(mq->next, &psize);
  if (mq->next->len == psize)
  {
     R= mq->next;
     mq->next= NULL;
     return R;
  }
  if (mq->next->len > psize)
  {
     R= malloc(sizeof(*R));
     R->data= mq->next->data;
     R->len = psize;
     mq->next->data += psize;
     mq->next->len -= psize;
     return R;
  }
  P= tssh_buffer_new(psize);
  memcpy(P->data, mq->next->data, mq->next->len);
  P->len = mq->next->len;
  free(mq->next);
  mq->next= NULL;
  mq->psize= psize;
  mq->partial= P;
  return NULL;
}
