

/***********************************************************************
 *                                                                     *
 *                         FTP Entry Functions                         *
 *                                                                     *
 ***********************************************************************/

void tssh_ftp_connect(tssh_t *T)
{
  tssh_put_thread_msg(&T->main_queue, 0, TSSH_CMD_FTP_CONNECT, 
                                         NULL, NULL, 0, NULL);
}

void tssh_ftp_disconnect(tssh_t *T)
{
  tssh_put_thread_msg(&T->main_queue, 0, TSSH_CMD_FTP_DISCONNECT, 
                                         NULL, NULL, 0, NULL);
}

void tssh_ftp_list(tssh_t *T, char *fn)
{
  tssh_ftop_t *op;
  op= tssh_ftop_new(TSSH_FTOP_LIST);
  op->fn= strdup(fn);
  tssh_put_thread_msg(&T->main_queue, 0, TSSH_CMD_QUEUE_FTOP,op,NULL,
                                         0,NULL);
}


void tssh_ftp_download_mem(tssh_t *T, char *fn)
{
  tssh_ftop_t *op;
  op= tssh_ftop_new(TSSH_FTOP_DOWNLOADMEM);
  op->fn= strdup(fn);
  tssh_put_thread_msg(&T->main_queue, 0, TSSH_CMD_QUEUE_FTOP,op,NULL,
                                         0,NULL);
}

void tssh_ftp_download_file(tssh_t *T, char *fn, char *localfn)
{
  tssh_ftop_t *op;
  op= tssh_ftop_new(TSSH_FTOP_DOWNLOADFILE);
  op->fn= strdup(fn);
  op->localfn= strdup(localfn);
  tssh_put_thread_msg(&T->main_queue, 0, TSSH_CMD_QUEUE_FTOP,op,NULL,
                                         0,NULL);
}

void tssh_ftp_upload_file(tssh_t *T, char *fn, char *localfn)
{
  tssh_ftop_t *op;
  op= tssh_ftop_new(TSSH_FTOP_UPLOADFILE);
  op->fn= strdup(fn);
  op->localfn= strdup(localfn);
  tssh_put_thread_msg(&T->main_queue, 0, TSSH_CMD_QUEUE_FTOP,op,NULL,
                                         0,NULL);
}

void tssh_ftp_upload_mem(tssh_t *T, char *fn, uint8_t *data, uint32_t len)
{
  tssh_ftop_t *op;
  op= tssh_ftop_new(TSSH_FTOP_UPLOADMEM);
  op->fn= strdup(fn);
  op->udata= data;
  op->size= len;
  tssh_put_thread_msg(&T->main_queue, 0, TSSH_CMD_QUEUE_FTOP,op,NULL,
                                         0,NULL);
}

void tssh_ftp_create_dir(tssh_t *T, char *fn)
{
  tssh_ftop_t *op;
  op= tssh_ftop_new(TSSH_FTOP_MKDIR);
  op->fn= strdup(fn);
  tssh_put_thread_msg(&T->main_queue, 0, TSSH_CMD_QUEUE_FTOP,op,NULL,
                                         0,NULL);
}

void tssh_ftp_remove_dir(tssh_t *T, char *fn)
{
  tssh_ftop_t *op;
  op= tssh_ftop_new(TSSH_FTOP_RMDIR);
  op->fn= strdup(fn);
  tssh_put_thread_msg(&T->main_queue, 0, TSSH_CMD_QUEUE_FTOP,op,NULL,
                                         0,NULL);
}

void tssh_ftp_remove_file(tssh_t *T, char *fn)
{
  tssh_ftop_t *op;
  op= tssh_ftop_new(TSSH_FTOP_RMFILE);
  op->fn= strdup(fn);
  tssh_put_thread_msg(&T->main_queue, 0, TSSH_CMD_QUEUE_FTOP,op,NULL,
                                         0,NULL);
}


void tssh_ftp_rename(tssh_t *T, char *oldfn, char* fn)
{
  tssh_ftop_t *op;
  op= tssh_ftop_new(TSSH_FTOP_RENAME);
  op->fn= strdup(fn);
  op->oldfn= strdup(oldfn);
  tssh_put_thread_msg(&T->main_queue, 0, TSSH_CMD_QUEUE_FTOP,op,NULL,
                                         0,NULL);
}

