#include <signal.h>
#include <stdio.h>
#include <termios.h>
#include <unistd.h>
#include "allcom.c"
#include "working.c"

#define FTP_TEST_MKDIR

void read_event(tssh_t *T)
{
  int i;
  tssh_event_t *E;
  tssh_buffer_t *buffer;
  char buf[400];
  int nfi;
  tssh_fileinfo_t *fi;
     FILE *out;
  void *data;
  size_t size;
  int len;

  E= tssh_get_event(T);
  switch(E->type)
  {
  case TSSH_EVENT_LOG: printf("L>%s", E->D.str); break;
  case TSSH_EVENT_CONNECT_BANNER: printf("B>%s", E->D.str); break;
  case TSSH_EVENT_PASSWORD_BANNER: printf("P>%s", E->D.str); break;
  case TSSH_EVENT_CONNECT_SUCCESS: 
     printf("Connection OK. Trying ftp channel.\n");
     tssh_ftp_connect(T);
     break;
  case TSSH_EVENT_CONNECT_FAILURE: 
     printf("Connection Failed\n");
     break;
  case TSSH_EVENT_FTP_CONNECT_FAILURE:
     printf("unable to connect to FTP server\n");
     break;
  case TSSH_EVENT_FTP_DISCONNECTED:
     printf("connection to FTP server was lost\n");
     break;
  case TSSH_EVENT_FTP_FAILURE:
       printf("ftp operation failed\n");
       break;
  case TSSH_EVENT_FTP_CONNECT_SUCCESS:
     printf("FTP Connection OK. Trying an operation.\n");
#ifdef FTP_TEST_MKDIR
     tssh_ftp_create_dir(T, "/tmp/testdir");
#endif
#ifdef FTP_TEST_LIST
     tssh_ftp_list(T, "/var/log");
#endif
#ifdef FTP_TEST_DOWNLOADMEM
    tssh_ftp_download_mem(T, "/home/test/testf/alice29.txt");
#endif
#ifdef FTP_TEST_DOWNLOADFILE
    tssh_ftp_download_file(T, "/home/test/testf/asyoulik.txt", "outfile2");
#endif 
#ifdef FTP_TEST_UPLOADFILE
    tssh_ftp_upload_file(T, "/tmp/testupload", "/usr/bin/mupanel" );
#endif
#ifdef FTP_TEST_UPLOADMEM
    out= fopen("/usr/bin/simplewm", "rb");
    data= malloc(10*1024*1024);
    len= fread(data, 1, 10*1024*1024, out);
    fclose(out);
    tssh_ftp_upload_mem(T, "/tmp/testmemupld", data, len);
#endif
  break;
  case TSSH_EVENT_FTP_SUCCESS:
    printf("file operation OK\n");
#ifdef FTP_TEST_LIST
     printf("==LIST /var/log ==\n");
     fi= E->fileinfo;
     nfi= E->n_fileinfo;
     for(i=0;i<nfi;i++)
       printf("%8d %s\n", (int) fi[i].size, fi[i].name);
     printf("==END==\n");
#endif
#ifdef FTP_TEST_DOWNLOADMEM
     printf("download OK\n");
     out= fopen("outfile", "wb");
     fwrite(E->buffer->data, 1, E->buffer->len, out);
     fclose(out);
#endif
#ifdef FTP_TEST_UPLOADMEM
     printf("upload mem ok\n");
     free(data);
#endif
     break;
  }
}

int main()
{
  tssh_t *T;
  T= tssh_init(NULL, "localhost", -1, "test", "hunter2");
  while(1) read_event(T);
  return 0;
}
